// Programmer: Maura Dailey

// Class: CSE 120
// Section: 1
// Date: 02/25/02

// Header file and specifications for the QueType class ADT. Note this is for
// a modified form that will store data inside of an unsigned integer.


#include <iostream>

class QueType
{
public:
  QueType();
  // Pre: None
  // Post: Queue and top have been initialized, and the control index has
  //  been set.

  void MakeEmpty();
  // Pre: Queue exists.
  // Post: Queue and top have been reinitialized to their starting values.

  bool IsEmpty() const;
  // Pre: Queue exists.
  // Post: True is returned if the queue is empty, false if the queue
  //  is not empty.

  bool IsFull() const;
  // Pre: Queue exists.
  // Post: True is returned if the queue is full, false if the queue
  //  is not full.

  void Enqueue(unsigned int newNode);
  // Pre: Queue exists and is not full. Enqueue must be called with an unsigned
  //   integer. Additionally, newNode must be some real positive integer
  //   from zero up to and including fifteen.
  // Post: newNode has been added to the bottom of the queue, top has been
  //   decremented to track the new top of the queue.

  void Dequeue(unsigned int& node);
  // Pre: Queue exists and is not empty. Dequeue must be called with an
  //   unsigned integer.
  // Post: Top of the queue has been assigned to node, top has been
  //   incremented to track the new top of the queue.

  void PrintQueue();
  // Pre: Queue exists and is not empty.
  // Post: File queue_output.dat has been created or appended to, contents
  //   of queue have been displayed to the screen and added to queue_output.dat.
  //   Additionally, if queue is empty, nothing will be returned.

private:
    unsigned int queue;
    int top;
    int index;
};